/*
 * Copyright 2006 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.unitils.dbmaintainer.structure;

/**
 * Defines the contract for implementations that create a DTD that describes a database. This DTD can
 * be used in XML files containing test data for a unit test database
 *
 * @author Filip Neven
 * @author Tim Ducheyne
 */
public interface DtdGenerator {


    /**
     * Generates the DTD
     */
    void generateDtd();

}
